import java.awt.*;
import java.awt.event.*;

public class universe extends Canvas { 

public final boolean simple_graphics=false;  
public boolean rain=false;    
public int size;
public final int imagesize=150*150;
public int doit;
public int pasteVal=0;
public static final int[][][] pasteArr={         //touch
                                        {{ 0, 2, 2, 2, 0},
                                         { 2, 0, 0, 0, 2},
                                         { 2, 0, 2, 0, 2},
                                         { 2, 0, 0, 0, 2},
                                         { 0, 2, 2, 2, 0}}
                                       };
public int borderStyle; //0: ("periodic/torus(donut)")
                                         //1: ("open / disc")
                                         //2: ("symmetric / mirror")
public cell upperleft;
public int[][] grid;
public int cellW;
public int cellH;
public java.util.Random fate;

public universe(int size, int borderStyle,timer globaltime,java.net.URL base,java.applet.Applet cheffe){
setEnabled(false);
if(base!=null){
 cheffe.showStatus("loading Background file...");
 java.net.URL temp=null;
 java.io.InputStream t=null;
 try{
   temp = new java.net.URL(base+"water.pcx");
  }catch(java.net.MalformedURLException e){System.err.println("URL error: "+e);}
  try{
   t=temp.openStream();
  }catch(java.io.IOException e){System.err.println("Could not establish connection: "+e);}
 PcxReader.loadImage(t);
}
else
try{
 PcxReader.loadImage(new java.io.FileInputStream("Water.pcx"));
}catch(java.io.FileNotFoundException e){System.err.println("background picture not found!");}
cell.imageArray=PcxReader.imageArray;
fate=new java.util.Random();
this.size=size;
this.borderStyle=borderStyle;
this.addMouseMotionListener(new MouseMotionListener(){
  public void mouseMoved(MouseEvent e){
    if(doit==0){
      onClick(e.getX(),e.getY());  //call this method on clicks with mouseposition
      doit=2;
      }
    else
      doit--;
  }
  public void mouseDragged(MouseEvent e){}
}
);
cell[][] field=new cell[size][size];

for(int y=0; y<size;y++)
  for(int x=0; x<size; x++){
    field[x][y]=new cell();
    if(x>0)
      field[x][y].setleft(field[x-1][y]);
    if(y>0)
      field[x][y].setup(field[x][y-1]);
    if(x==0){  //huge conditions to make the cells know what kind of cell they are (e.g. edge cell) cf. cell.posType
      if(y==0){
      upperleft=field[x][y];
      upperleft.posType=0;
      }else
        if(y==size-1)
         field[x][y].posType=2;
         else
           field[x][y].posType=1;
    }else
      if(x==size-1){
       if(y==0)
         field[x][y].posType=6;
         else
         if(y==size-1)
           field[x][y].posType=8;
           else
             field[x][y].posType=7;
      }else
        if(y==0)
         field[x][y].posType=3;
         else
            if(y==size-1)
             field[x][y].posType=5;
             else
              field[x][y].posType=4; 
   }
cell.setTime(globaltime);
cell.setUniverse(this);
updateBorder();
}

public void update(){
upperleft.update();
//repaint(); check here for speed optimizations... maybe an arraylist with squares that need update
}

public void increase(){
size=size+10;
upperleft.inc(this);
upperleft.inc(this);
upperleft.inc(this);
upperleft.inc(this);
upperleft.inc(this);
}

public void updateBorder(){
upperleft.updateBorder(borderStyle);
grid=new int[size][size];
upperleft.xy((short)0,(short)0);
}

public void showAll(){
updateBorder();
//System.err.println("finally done!");
}

public cell search=null;

public cell getCellAt(int x, int y){
upperleft.get(x/cellW,y/cellH);
return search;
  }

public void onClick(int x,int y){
if(!this.isEnabled()) return;
  cellW=getWidth()/size;
  cellH=getHeight()/size;
  cell active=getCellAt(x,y);
  if(active!=null){
    active.paste(pasteArr[pasteVal]);
  search=null;
  repaint((long)100,active.x*cellW,active.y*cellH,pasteArr[pasteVal][0].length*cellW,pasteArr[pasteVal].length*cellH);
//repaint();
    }
}

private Image offScreenImage = null;
private Graphics offScreenGraphics;

public synchronized void update( Graphics theG )
{
Dimension d = getSize();
if((offScreenImage == null) ) {
  offScreenImage = createImage( d.width, d.height );
  offScreenGraphics = offScreenImage.getGraphics();
}
paint(offScreenGraphics);
theG.drawImage( offScreenImage, 0, 0, null );
}

// paint method
public void paint(Graphics g){
if((getWidth()/size!=cellW)||(getHeight()/size!=cellH))
  {
  cellW=getWidth()/size;
  cellH=getHeight()/size;
  }
for(short y=0; y<size; y++)
  for(short x=0; x<size;){
    g.setColor(new Color(grid[x][y]));
    g.fillRect(x++*cellW,y*cellH,cellW,cellH);
    }
}

public void repaint(){
  cellW=getWidth()/size;
  cellH=getHeight()/size;
super.repaint();
}

public Dimension getMinimumSize(){
return new Dimension(size*3,size*3);
}

public Dimension getMaximumSize(){
return new Dimension(2100,2100);
}

public Dimension getPreferredSize(){
return new Dimension(700,700);
}

}
